/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (4.2.2).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package com.t5g.nf.nrf.nfdiscovery.api;

import java.util.UUID;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;

import com.t5g.nf.nrf.nfdiscovery.model.AccessType;
import com.t5g.nf.nrf.nfdiscovery.model.ComplexQuery;
import com.t5g.nf.nrf.nfdiscovery.model.DataSetId;
import com.t5g.nf.nrf.nfdiscovery.model.Guami;
import com.t5g.nf.nrf.nfdiscovery.model.NFType;
import com.t5g.nf.nrf.nfdiscovery.model.PduSessionType;
import com.t5g.nf.nrf.nfdiscovery.model.PlmnId;
import com.t5g.nf.nrf.nfdiscovery.model.PlmnSnssai;
import com.t5g.nf.nrf.nfdiscovery.model.ProblemDetails;
import com.t5g.nf.nrf.nfdiscovery.model.SearchResult;
import com.t5g.nf.nrf.nfdiscovery.model.ServiceName;
import com.t5g.nf.nrf.nfdiscovery.model.Snssai;
import com.t5g.nf.nrf.nfdiscovery.model.Tai;
import com.t5g.nf.nrf.nfdiscovery.util.JsonUtil;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2019-12-12T15:13:35.669+02:00[Europe/Helsinki]")

@Validated
@Api(value = "nf-instances", description = "the nf-instances API")
public interface NfInstancesApi {

	default Optional<NativeWebRequest> getRequest() {
		return Optional.empty();
	}

	@ApiOperation(value = "Search a collection of NF Instances", nickname = "searchNFInstances", notes = "", response = SearchResult.class, authorizations = {
			@Authorization(value = "oAuth2ClientCredentials", scopes = {
					@AuthorizationScope(scope = "nnrf-disc", description = "Access to the Nnrf_NFDiscovery API") }) }, tags = {
							"NF Instances (Store)", })
	@ApiResponses(value = {
			@ApiResponse(code = 200, message = "Expected response to a valid request", response = SearchResult.class),
			@ApiResponse(code = 307, message = "Temporary Redirect"),
			@ApiResponse(code = 400, message = "Bad request", response = ProblemDetails.class),
			@ApiResponse(code = 401, message = "Unauthorized", response = ProblemDetails.class),
			@ApiResponse(code = 403, message = "Forbidden", response = ProblemDetails.class),
			@ApiResponse(code = 404, message = "Not Found", response = ProblemDetails.class),
			@ApiResponse(code = 406, message = "406 Not Acceptable"),
			@ApiResponse(code = 411, message = "Length Required", response = ProblemDetails.class),
			@ApiResponse(code = 413, message = "Payload Too Large", response = ProblemDetails.class),
			@ApiResponse(code = 415, message = "Unsupported Media Type", response = ProblemDetails.class),
			@ApiResponse(code = 429, message = "Too Many Requests", response = ProblemDetails.class),
			@ApiResponse(code = 500, message = "Internal Server Error", response = ProblemDetails.class),
			@ApiResponse(code = 501, message = "Not Implemented", response = ProblemDetails.class),
			@ApiResponse(code = 503, message = "Service Unavailable", response = ProblemDetails.class),
			@ApiResponse(code = 200, message = "Generic Error") })
	@RequestMapping(value = "/nf-instances", produces = { "application/json",
			"application/problem+json" }, method = RequestMethod.GET)
	default ResponseEntity<SearchResult> searchNFInstances(
			@NotNull @ApiParam(value = "Type of the target NF", required = true, allowableValues = "NRF, UDM, AMF, SMF, AUSF, NEF, PCF, SMSF, NSSF, UDR, LMF, GMLC, 5G_EIR, SEPP, UPF, N3IWF, AF, UDSF, BSF, CHF, NWDAF") @Valid @RequestParam(value = "target-nf-type", required = true) NFType targetNfType,
			@NotNull @ApiParam(value = "Type of the requester NF", required = true, allowableValues = "NRF, UDM, AMF, SMF, AUSF, NEF, PCF, SMSF, NSSF, UDR, LMF, GMLC, 5G_EIR, SEPP, UPF, N3IWF, AF, UDSF, BSF, CHF, NWDAF") @Valid @RequestParam(value = "requester-nf-type", required = true) NFType requesterNfType,
			@Size(min = 1) @ApiParam(value = "Names of the services offered by the NF") @Valid @RequestParam(value = "service-names", required = false) List<ServiceName> serviceNames,
			@ApiParam(value = "FQDN of the requester NF") @Valid @RequestParam(value = "requester-nf-instance-fqdn", required = false) String requesterNfInstanceFqdn,
			@Size(min = 1) @ApiParam(value = "Id of the PLMN of the target NF") @Valid @RequestParam(value = "target-plmn-list", required = false) List<PlmnId> targetPlmnList,
			@Size(min = 1) @ApiParam(value = "Id of the PLMN where the NF issuing the Discovery request is located") @Valid @RequestParam(value = "requester-plmn-list", required = false) List<PlmnId> requesterPlmnList,
			@ApiParam(value = "Identity of the NF instance being discovered") @Valid @RequestParam(value = "target-nf-instance-id", required = false) UUID targetNfInstanceId,
			@ApiParam(value = "FQDN of the NF instance being discovered") @Valid @RequestParam(value = "target-nf-fqdn", required = false) String targetNfFqdn,
			@ApiParam(value = "Uri of the home NRF") @Valid @RequestParam(value = "hnrf-uri", required = false) String hnrfUri,
			@Size(min = 1) @ApiParam(value = "Slice info of the target NF") @Valid @RequestParam(value = "snssais", required = false) List<Snssai> snssais,
			@Size(min = 1) @ApiParam(value = "Slice info of the requester NF") @Valid @RequestParam(value = "requester-snssais", required = false) List<Snssai> requesterSnssais,
			@Size(min = 1) @ApiParam(value = "PLMN specific Slice info of the target NF") @Valid @RequestParam(value = "plmn-specific-snssai-list", required = false) List<PlmnSnssai> plmnSpecificSnssaiList,
			@ApiParam(value = "Dnn supported by the BSF, SMF or UPF") @Valid @RequestParam(value = "dnn", required = false) String dnn,
			@Size(min = 1) @ApiParam(value = "NSI IDs that are served by the services being discovered") @Valid @RequestParam(value = "nsi-list", required = false) List<String> nsiList,
			@ApiParam(value = "") @Valid @RequestParam(value = "smf-serving-area", required = false) String smfServingArea,
			@ApiParam(value = "Tracking Area Identity") @Valid Tai tai,
			/*@ApiParam(value = "Tracking Area Identity") @Valid @RequestParam(value = "tai", required = false) Tai tai,*/
			@Pattern(regexp = "^[A-Fa-f0-9]{2}$") @ApiParam(value = "AMF Region Identity") @Valid @RequestParam(value = "amf-region-id", required = false) String amfRegionId,
			@Pattern(regexp = "^[0-3][A-Fa-f0-9]{2}$") @ApiParam(value = "AMF Set Identity") @Valid @RequestParam(value = "amf-set-id", required = false) String amfSetId,
			/*@ApiParam(value = "Guami used to search for an appropriate AMF") @Valid Guami guami,*/
			@Pattern(regexp = "^(imsi-[0-9]{5,15}|nai-.+|.+)$") @ApiParam(value = "SUPI of the user") @Valid @RequestParam(value = "supi", required = false) String supi,
			@Pattern(regexp = "^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$") @ApiParam(value = "IPv4 address of the UE") @Valid @RequestParam(value = "ue-ipv4-address", required = false) String ueIpv4Address,
			@ApiParam(value = "IP domain of the UE, which supported by BSF") @Valid @RequestParam(value = "ip-domain", required = false) String ipDomain,
			@ApiParam(value = "IPv6 prefix of the UE") @Valid String ueIpv6Prefix,
			@ApiParam(value = "Combined PGW-C and SMF or a standalone SMF") @Valid @RequestParam(value = "pgw-ind", required = false) Boolean pgwInd,
			@ApiParam(value = "PGW FQDN of a combined PGW-C and SMF") @Valid @RequestParam(value = "pgw", required = false) String pgw,
			@Pattern(regexp = "^(msisdn-[0-9]{5,15}|extid-[^@]+@[^@]+|.+)$") @ApiParam(value = "GPSI of the user") @Valid @RequestParam(value = "gpsi", required = false) String gpsi,
			@ApiParam(value = "external group identifier of the user") @Valid @RequestParam(value = "external-group-identity", required = false) String externalGroupIdentity,
			@ApiParam(value = "data set supported by the NF", defaultValue = "null") @Valid DataSetId dataSet,
			@Pattern(regexp = "^[0-9]{1,4}$") @ApiParam(value = "routing indicator in SUCI") @Valid @RequestParam(value = "routing-indicator", required = false) String routingIndicator,
			@Size(min = 1) @ApiParam(value = "Group IDs of the NFs being discovered") @Valid @RequestParam(value = "group-id-list", required = false) List<String> groupIdList,
			@Size(min = 1) @ApiParam(value = "Data network access identifiers of the NFs being discovered") @Valid @RequestParam(value = "dnai-list", required = false) List<String> dnaiList,
			@Size(min = 1) @ApiParam(value = "list of PDU Session Type required to be supported by the target NF") @Valid @RequestParam(value = "pdu-session-types", required = false) List<PduSessionType> pduSessionTypes,
			@Pattern(regexp = "^[A-Fa-f0-9]*$") @ApiParam(value = "Features required to be supported by the target NF") @Valid @RequestParam(value = "supported-features", required = false) String supportedFeatures,
			@ApiParam(value = "UPF supporting interworking with EPS or not") @Valid @RequestParam(value = "upf-iwk-eps-ind", required = false) Boolean upfIwkEpsInd,
			/*@ApiParam(value = "PLMN ID supported by a CHF") @Valid PlmnId chfSupportedPlmn, */
			/*Modified*/@ApiParam(value = "PLMN ID supported by a CHF") @Valid @RequestParam(value = "chf-supported-plmn", required = false) String chfSupportedPlmn,
			@ApiParam(value = "preferred target NF location") @Valid @RequestParam(value = "preferred-locality", required = false) String preferredLocality,
			@ApiParam(value = "AccessType supported by the target NF", allowableValues = "3GPP_ACCESS, NON_3GPP_ACCESS") @Valid @RequestParam(value = "access-type", required = false) AccessType accessType,
			@Min(1) @ApiParam(value = "Maximum number of NFProfiles to return in the response") @Valid @RequestParam(value = "limit", required = false) Integer limit,
			@Size(min = 1) @ApiParam(value = "Features required to be supported by the target NF") @Valid @RequestParam(value = "required-features", required = false) List<String> requiredFeatures,
			/*@ApiParam(value = "the complex query condition expression", defaultValue = "null") @Valid ComplexQuery complexQuery,*/
			@Max(2000) @ApiParam(value = "Maximum payload size of the response expressed in kilo octets", defaultValue = "124") @Valid @RequestParam(value = "max-payload-size", required = false, defaultValue = "124") Integer maxPayloadSize,
			@ApiParam(value = "Validator for conditional requests, as described in IETF RFC 7232, 3.2") @RequestHeader(value = "If-None-Match", required = false) String ifNoneMatch) {
		getRequest().ifPresent(request -> {
			for (MediaType mediaType : MediaType.parseMediaTypes(request.getHeader("Accept"))) {
				if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
					if (chfSupportedPlmn != null) {
						PlmnId plmnId;
						try {
							plmnId = JsonUtil.toObject(chfSupportedPlmn, PlmnId.class);
							System.out.println("chfSupportedPlmn: " + plmnId);
						} catch (Exception e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
					}

					String exampleString = "{ \"validityPeriod\" : 0, \"nfInstances\" : [ { \"sNssais\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ], \"pcfInfo\" : { \"rxDiamHost\" : \"rxDiamHost\", \"dnnList\" : [ null, null ], \"rxDiamRealm\" : \"rxDiamRealm\", \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"ipv6Addresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"customInfo\" : \"{}\", \"plmnList\" : [ { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } ], \"udmInfo\" : { \"routingIndicators\" : [ \"routingIndicators\", \"routingIndicators\" ], \"groupId\" : \"groupId\", \"externalGroupIdentifiersRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"gpsiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"capacity\" : 9606, \"nsiList\" : [ \"nsiList\", \"nsiList\" ], \"load\" : 59, \"nfServices\" : [ { \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"supportedFeatures\" : \"supportedFeatures\", \"fqdn\" : \"fqdn\", \"serviceInstanceId\" : \"serviceInstanceId\", \"priority\" : 23697, \"capacity\" : 46276, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"load\" : 93, \"versions\" : [ { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" }, { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" } ], \"ipEndPoints\" : [ { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" }, { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" } ], \"apiPrefix\" : \"apiPrefix\", \"chfServiceInfo\" : { \"primaryChfServiceInstance\" : \"primaryChfServiceInstance\", \"secondaryChfServiceInstance\" : \"secondaryChfServiceInstance\" } }, { \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"supportedFeatures\" : \"supportedFeatures\", \"fqdn\" : \"fqdn\", \"serviceInstanceId\" : \"serviceInstanceId\", \"priority\" : 23697, \"capacity\" : 46276, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"load\" : 93, \"versions\" : [ { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" }, { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" } ], \"ipEndPoints\" : [ { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" }, { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" } ], \"apiPrefix\" : \"apiPrefix\", \"chfServiceInfo\" : { \"primaryChfServiceInstance\" : \"primaryChfServiceInstance\", \"secondaryChfServiceInstance\" : \"secondaryChfServiceInstance\" } } ], \"perPlmnSnssaiList\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"sNssaiList\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ] }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"sNssaiList\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ] } ], \"udrInfo\" : { \"supportedDataSets\" : [ null, null ], \"groupId\" : \"groupId\", \"externalGroupIdentifiersRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"gpsiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"ausfInfo\" : { \"routingIndicators\" : [ \"routingIndicators\", \"routingIndicators\" ], \"groupId\" : \"groupId\", \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"nfServicePersistence\" : false, \"ipv4Addresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"nfInstanceId\" : \"046b6c7f-0b8a-43b9-b35d-6489e6daee91\", \"upfInfo\" : { \"iwkEpsInd\" : false, \"interfaceUpfInfoList\" : [ { \"networkInstance\" : \"networkInstance\", \"ipv4EndpointAddresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"ipv6EndpointAddresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"endpointFqdn\" : \"endpointFqdn\" }, { \"networkInstance\" : \"networkInstance\", \"ipv4EndpointAddresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"ipv6EndpointAddresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"endpointFqdn\" : \"endpointFqdn\" } ], \"smfServingArea\" : [ \"smfServingArea\", \"smfServingArea\" ], \"pduSessionTypes\" : [ null, null ], \"sNssaiUpfInfoList\" : [ { \"dnnUpfInfoList\" : [ { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } }, { \"dnnUpfInfoList\" : [ { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } } ] }, \"bsfInfo\" : { \"dnnList\" : [ null, null ], \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"ipDomainList\" : [ \"ipDomainList\", \"ipDomainList\" ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, \"fqdn\" : \"fqdn\", \"locality\" : \"locality\", \"priority\" : 36944, \"chfInfo\" : { \"gpsiRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"amfInfo\" : { \"backupInfoAmfRemoval\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"guamiList\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"taiRangeList\" : [ { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"backupInfoAmfFailure\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"amfSetId\" : \"amfSetId\", \"amfRegionId\" : \"amfRegionId\", \"n2InterfaceAmfInfo\" : { \"ipv4EndpointAddress\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"amfName\" : \"amfName\", \"ipv6EndpointAddress\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ] }, \"taiList\" : [ { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ] }, \"smfInfo\" : { \"accessType\" : [ null, null ], \"sNssaiSmfInfoList\" : [ { \"dnnSmfInfoList\" : [ { \"dnn\" : \"dnn\" }, { \"dnn\" : \"dnn\" } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } }, { \"dnnSmfInfoList\" : [ { \"dnn\" : \"dnn\" }, { \"dnn\" : \"dnn\" } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } } ], \"taiRangeList\" : [ { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"taiList\" : [ { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"pgwFqdn\" : \"pgwFqdn\" } }, { \"sNssais\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ], \"pcfInfo\" : { \"rxDiamHost\" : \"rxDiamHost\", \"dnnList\" : [ null, null ], \"rxDiamRealm\" : \"rxDiamRealm\", \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"ipv6Addresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"customInfo\" : \"{}\", \"plmnList\" : [ { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } ], \"udmInfo\" : { \"routingIndicators\" : [ \"routingIndicators\", \"routingIndicators\" ], \"groupId\" : \"groupId\", \"externalGroupIdentifiersRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"gpsiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"capacity\" : 9606, \"nsiList\" : [ \"nsiList\", \"nsiList\" ], \"load\" : 59, \"nfServices\" : [ { \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"supportedFeatures\" : \"supportedFeatures\", \"fqdn\" : \"fqdn\", \"serviceInstanceId\" : \"serviceInstanceId\", \"priority\" : 23697, \"capacity\" : 46276, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"load\" : 93, \"versions\" : [ { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" }, { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" } ], \"ipEndPoints\" : [ { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" }, { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" } ], \"apiPrefix\" : \"apiPrefix\", \"chfServiceInfo\" : { \"primaryChfServiceInstance\" : \"primaryChfServiceInstance\", \"secondaryChfServiceInstance\" : \"secondaryChfServiceInstance\" } }, { \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"supportedFeatures\" : \"supportedFeatures\", \"fqdn\" : \"fqdn\", \"serviceInstanceId\" : \"serviceInstanceId\", \"priority\" : 23697, \"capacity\" : 46276, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"load\" : 93, \"versions\" : [ { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" }, { \"apiFullVersion\" : \"apiFullVersion\", \"apiVersionInUri\" : \"apiVersionInUri\", \"expiry\" : \"2000-01-23T04:56:07.000+00:00\" } ], \"ipEndPoints\" : [ { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" }, { \"ipv6Address\" : \"2001:db8:85a3::8a2e:370:7334\", \"port\" : 15087, \"ipv4Address\" : \"198.51.100.1\" } ], \"apiPrefix\" : \"apiPrefix\", \"chfServiceInfo\" : { \"primaryChfServiceInstance\" : \"primaryChfServiceInstance\", \"secondaryChfServiceInstance\" : \"secondaryChfServiceInstance\" } } ], \"perPlmnSnssaiList\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"sNssaiList\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ] }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"sNssaiList\" : [ { \"sd\" : \"sd\", \"sst\" : 153 }, { \"sd\" : \"sd\", \"sst\" : 153 } ] } ], \"udrInfo\" : { \"supportedDataSets\" : [ null, null ], \"groupId\" : \"groupId\", \"externalGroupIdentifiersRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"gpsiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"ausfInfo\" : { \"routingIndicators\" : [ \"routingIndicators\", \"routingIndicators\" ], \"groupId\" : \"groupId\", \"supiRanges\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"nfServicePersistence\" : false, \"ipv4Addresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"recoveryTime\" : \"2000-01-23T04:56:07.000+00:00\", \"nfInstanceId\" : \"046b6c7f-0b8a-43b9-b35d-6489e6daee91\", \"upfInfo\" : { \"iwkEpsInd\" : false, \"interfaceUpfInfoList\" : [ { \"networkInstance\" : \"networkInstance\", \"ipv4EndpointAddresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"ipv6EndpointAddresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"endpointFqdn\" : \"endpointFqdn\" }, { \"networkInstance\" : \"networkInstance\", \"ipv4EndpointAddresses\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"ipv6EndpointAddresses\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ], \"endpointFqdn\" : \"endpointFqdn\" } ], \"smfServingArea\" : [ \"smfServingArea\", \"smfServingArea\" ], \"pduSessionTypes\" : [ null, null ], \"sNssaiUpfInfoList\" : [ { \"dnnUpfInfoList\" : [ { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } }, { \"dnnUpfInfoList\" : [ { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, { \"dnaiList\" : [ null, null ], \"dnn\" : \"dnn\", \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"pduSessionTypes\" : [ null, null ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } } ] }, \"bsfInfo\" : { \"dnnList\" : [ null, null ], \"ipv6PrefixRanges\" : [ { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" }, { \"start\" : \"2001:db8:abcd:12::0/64\", \"end\" : \"2001:db8:abcd:12::0/64\" } ], \"ipDomainList\" : [ \"ipDomainList\", \"ipDomainList\" ], \"ipv4AddressRanges\" : [ { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" }, { \"start\" : \"198.51.100.1\", \"end\" : \"198.51.100.1\" } ] }, \"fqdn\" : \"fqdn\", \"locality\" : \"locality\", \"priority\" : 36944, \"chfInfo\" : { \"gpsiRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"supiRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ] }, \"defaultNotificationSubscriptions\" : [ { \"callbackUri\" : \"callbackUri\" }, { \"callbackUri\" : \"callbackUri\" } ], \"amfInfo\" : { \"backupInfoAmfRemoval\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"guamiList\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"taiRangeList\" : [ { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"backupInfoAmfFailure\" : [ { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" }, { \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" }, \"amfId\" : \"amfId\" } ], \"amfSetId\" : \"amfSetId\", \"amfRegionId\" : \"amfRegionId\", \"n2InterfaceAmfInfo\" : { \"ipv4EndpointAddress\" : [ \"198.51.100.1\", \"198.51.100.1\" ], \"amfName\" : \"amfName\", \"ipv6EndpointAddress\" : [ \"2001:db8:85a3::8a2e:370:7334\", \"2001:db8:85a3::8a2e:370:7334\" ] }, \"taiList\" : [ { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ] }, \"smfInfo\" : { \"accessType\" : [ null, null ], \"sNssaiSmfInfoList\" : [ { \"dnnSmfInfoList\" : [ { \"dnn\" : \"dnn\" }, { \"dnn\" : \"dnn\" } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } }, { \"dnnSmfInfoList\" : [ { \"dnn\" : \"dnn\" }, { \"dnn\" : \"dnn\" } ], \"sNssai\" : { \"sd\" : \"sd\", \"sst\" : 153 } } ], \"taiRangeList\" : [ { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tacRangeList\" : [ { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" }, { \"start\" : \"start\", \"pattern\" : \"pattern\", \"end\" : \"end\" } ], \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"taiList\" : [ { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } }, { \"tac\" : \"tac\", \"plmnId\" : { \"mnc\" : \"mnc\", \"mcc\" : \"mcc\" } } ], \"pgwFqdn\" : \"pgwFqdn\" } } ], \"nrfSupportedFeatures\" : \"nrfSupportedFeatures\" }";
					ApiUtil.setExampleResponse(request, "application/json", exampleString);
					break;
				}
			}
		});
		return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

	}

}
